#!/usr/bin/python
#-*- coding: utf-8 -*-

import MySQLdb
import time
import os

def test(baglanti):
	try:
		db=MySQLdb.connect(host=baglanti[0],user=baglanti[1],passwd=baglanti[2],db=baglanti[3])
		return True
	except:
		return False

def ipCek(dizi,i,bilgi):
	ip=dizi[i].split('for ')
	return ip[1][:-1]

def ipSelf(arayuz):
	import os
	cikti=os.popen("ifconfig "+arayuz)
	dizi=cikti.readlines()
	i=0
	while (i<len(dizi)):
		if (dizi[i].find('inet addr:')!=-1):
			bol=dizi[i].split('inet addr:')
			ip=bol[1].split(' ')[0]
			break
		i=i+1
	return ip.strip()

def macSelf(arayuz):
	import os
	cikti=os.popen("ifconfig "+arayuz)
	dizi=cikti.readlines()
	i=0
	while (i<len(dizi)):
		if (dizi[i].find('HWaddr')!=-1):
			bol=dizi[i].split('HWaddr ')
			mac=bol[1][:-1]
			break
		i=i+1
	return mac.strip()

def osSelf():
	import os
	cikti=os.popen("uname -sr")
	dizi=cikti.readlines()
	return dizi[0][:-1].strip()

def portlar(dizi,i):
	sonuc=""
	while (1):
		bol=dizi[i].split(' ')
		if (bol[0][0].isdigit()):
			sonuc=sonuc+bol[0]+" "
		else:
			break
		i=i+1
	return sonuc

def macadres(dizi,i):
	return dizi[i].split(' ')[2].strip()

def osdetay(dizi,i):
	return dizi[i].split('unning: ')[1][:-1].strip()

def grupbak(ip,baglanti):
	db=MySQLdb.connect(host=baglanti[0],user=baglanti[1],passwd=baglanti[2],db=baglanti[3])
	komut=db.cursor()
	bol=ip.split('.')
	grup=bol[0]+"."+bol[1]+"."+bol[2]
	komut.execute("select * from grup where grupip='"+grup+"'")
	sonuc=komut.rowcount
	if (sonuc==0):
		grupekle=db.cursor()
		grupekle.execute("insert into grup (grupip) values ('"+grup+"')")
		return int(grupekle.lastrowid)
	else:
		return komut.fetchone()[0]

def zamancek(zaman,baglanti):
	db=MySQLdb.connect(host=baglanti[0],user=baglanti[1],passwd=baglanti[2],db=baglanti[3])
	komut=db.cursor()
	komut.execute("insert into info (zaman) values ("+str(zaman)+")")
	return int(komut.lastrowid)

def mysqlekle(ip,mac,port,os2,zaman,baglanti):
	db=MySQLdb.connect(host=baglanti[0],user=baglanti[1],passwd=baglanti[2],db=baglanti[3])
	grup=grupbak(ip,baglanti)
	komut=db.cursor()
	komut.execute("insert into logs (ip, mac, os, ports, grup, tarama) values ('"+ip+"', '"+mac+"', '"+os2+"', '"+port+"', "+str(grup)+", "+str(zaman)+")")
	
def arpbak(ip,bilgi):
	import os
	cikti=os.popen("arp-scan -I "+bilgi[5]+" "+ip)
	dizi=cikti.readlines()
	i=0
	mac=""
	while (i<len(dizi)):
		if (dizi[i].find(ip)!=-1):
			bol=dizi[i].split('\t')
			mac=bol[1]
			break
		i=i+1
	return mac.strip()

def baglanti():
	dosya=open('/etc/netChecker.conf','r')
	dizi=dosya.readlines()
	i=0
	host=user=pwd=db=scanip=netmask=inter=""
	while (i<len(dizi)):
		if (dizi[i].find('hostName')!=-1):
			host=dizi[i].split(' ')[1][:-1]
		elif (dizi[i].find('userName')!=-1):
			user=dizi[i].split(' ')[1][:-1]
		elif (dizi[i].find('password')!=-1):
			pwd=dizi[i].split(' ')[1][:-1]
		elif (dizi[i].find('scanip')!=-1):
			scanip=dizi[i].split(' ')[1][:-1]
		elif (dizi[i].find('netmsk')!=-1):
			netmask=dizi[i].split(' ')[1][:-1]
		elif (dizi[i].find('netface')!=-1):
			inter=dizi[i].split(' ')[1][:-1]
		elif (dizi[i].find('tcp')!=-1):
			deger=dizi[i].split(' ')[1][:-1]
			if (deger=="true"):
				tcp="-sS"
			else:
				tcp=""
		elif (dizi[i].find('udp')!=-1):
			deger=dizi[i].split(' ')[1][:-1]
			if (deger=="true"):
				udp="-sU"
			else:
				udp=""
			break
		i=i+1
	db="iplog"
	sonuc=[host,user,pwd,db,scanip+"/"+netmask,inter,tcp,udp]
	return sonuc

cikti=os.popen("whoami")
kim=cikti.readlines()
if (kim[0].find('root')==-1):
	print "Programı kullanabilmeniz için root olmanız gerekli!"
else:
	if not (os.path.exists("/etc/netChecker.conf")):
		print "/etc/netChecker.conf konfigürasyon dosyası bulunamadı. Program kapatılıyor!"
	else:
		baglantiBilgileri=baglanti()
		if (test(baglantiBilgileri)):
			print "Log alınırken lütfen bekleyiniz...\nBu işlem ağın büyüklüğüne göre birkaç dakika sürebilir."	
			simdi=int(time.time())
			taramaZamani=zamancek(simdi,baglantiBilgileri)
			std=time.localtime(simdi)
			islemZamani=str(std[2])+"."+str(std[1])+"."+str(std[0])+" - "+str(std[3])+":"+str(std[4])+":"+str(std[5])
			print "Loglama başlangıcı: "+islemZamani
	
			sorgu="nmap -O -n -P0 "+baglantiBilgileri[6]+" "+baglantiBilgileri[7]+" "+baglantiBilgileri[4]+" > /tmp/tarama.txt"
			os.system(sorgu)
	
			dosya=open('/tmp/tarama.txt','r')
			dizi=dosya.readlines()
			i=0
			ip=mac=port=os2=""
			while (i<len(dizi)):
				son=len(dizi)
				if (dizi[i].find('Nmap scan report for')!=-1):
					j=i+1
					ilk=i
					while (j<len(dizi)):
						if (dizi[j].find('Nmap scan report for')!=-1):
							son=j
							break
						j=j+1
					if (j==len(dizi)):
						son=len(dizi)

					ip=ipCek(dizi,i,baglantiBilgileri)
					j=ilk
					while (j<son):
						if (dizi[j].find('PORT ')!=-1):
							port=portlar(dizi,j+1)
							break
						j=j+1
					j=ilk
					while (j<son):
						if (dizi[j].find('MAC Address:')!=-1):
							mac=macadres(dizi,j)
							if (len(mac)!=17):
								mac=arpbak(ip,baglantiBilgileri)
							break
						j=j+1
						if (j==son):
							mac=arpbak(ip,baglantiBilgileri)
					if (ip==ipSelf(baglantiBilgileri[5])):
						mac=str(macSelf(baglantiBilgileri[5]))
	
					j=ilk
					while (j<son):
						if (dizi[j].find('Running:')!=-1):
							os2=osdetay(dizi,j)
							break
						j=j+1
					if (os2==""):
						if (ip==ipSelf(baglantiBilgileri[5])):
							os2=osSelf()
	
					#print "IP: "+ip+"\nMAC: "+mac+"\nPort: "+port+"\nOS: "+os
					mysqlekle(ip,mac,port,os2,taramaZamani,baglantiBilgileri)
					ip=mac=port=os2=""
					i=son-1
				else:
					i=i+1

			if (os.path.exists("/tmp/tarama.txt")):
				os.system("rm /tmp/tarama.txt")
			print "\nLog işlemi tamamlandı..."
		else:
			print "/etc/netChecker.conf dosyasındaki bilgilerle veritabanı erişimi sağlanamadı.\nLütfen bilgileri kontrol edip tekrar deneyin.\n\nProgramdan çıkılıyor..."
